; first updated 06/07/91
; updated 09/18/92

;=======================================================================
;   Copyright (C) Copr. 1991, 1992 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=======================================================================
; RM120TS8,16,24,32,40,48

;TANDY and old COMPAQ's don't use the BIOS pointers for current
;status of keyboard buffer
HAVETANDY   EQU    0    ; 0 = don't configure for TANDY 1000 series

; If want to add support for WINDOWS Ver 3, OS/2 time slice calls
; change value to 1, note WINDOWS requires DOS version 3.xx+
; Unfortunately, Windows 3.XX will rarely return the favor and call
; the DOS routine back, so don't bother unless use OS/2
; Per P.C. Magazine
SUPPORTWIN  EQU    0    ; 0 = don't configure for WINDOWS

;Allow programmer to know what is what w/ keyboard
ASCIICode   EQU    <AL>
ScanCode    EQU    <AH>

DOSSEG
.MODEL MEDIUM, BASIC

BIOSRAM SEGMENT AT 0            ;make ASSUMEs more readable
BIOSRAM ENDS

; Contains:  WAITFORKEY, CLRKBD, KEYPAUSE

                      INCLUDE KEY.INC
.CODE

; Please do not remove
Copyright       DB    13,10,'Copyright Copr. (C) 1991, 1992, 1993 Sidney J. Kelly',13,10
Copyright1      DB    'All Rights Reserved',13,10,26

;===========================================================================
; DECLARE FUNCTION WAITFORKEY%()
; Looks for key press,
; Returns: -256 if none pending
;           a positive number, [e.g. ASC(INKEY$)] if a normal key found.
;           a negative scan code if an extended key key pressed.
;
; Only initializes itself one time.  Works w/ Normal and Extended KDBS
;===========================================================================

EVEN
WAITFORKEY PROC FAR BASIC
	Cmp     B$KBD_Inst,0    ; have we installed before
	JE      Do_Install      ; if no, then do it
Main:                           ; else find keystroke
	; sets Zero flag if no character is pending
	Mov     AH,1            ; any keycode waiting?
	Or      AH,Byte Ptr B$KBD_Type ; use extended kbd function if avail
	Int     16h             ; call BIOS
	JZ      No_Key_There    ; if ZF then no key, and skip ahead
	Xor     AH,AH           ; else so get it & read keycode word
	Or      AH,Byte Ptr B$KBD_Type ; use extended kbd function if avail
	Int     16h             ; use BIOS
	OR      ASCIICode,ASCIICode  ; if AL = 0 then have extended keycode
	JZ      GotExtCode      ; jump to that routine
	Cmp     ASCIICode,0E0h  ; to eliminate extended keycode byte of 0E0h
				; assumes AT kbd not in SCANMODE 3
	JE      GotExtCode      ; (that is a very legit assumption)
	Xor     ScanCode,ScanCode ; got normal key, clear Scan code
	Ret                     ; return and quit
EVEN
GotExtCode:                     ; make extended keycode return a neg number
	Mov     AL,ScanCode     ; put scan in AL
	Xor     AH,AH           ; clear AH
	Neg     AX              ; does fast 2's complement
	Ret                     ; return and quit
EVEN
No_Key_There:
	Int	28h		; tell DOS & TSR's nothing happening
IF SUPPORTWIN
	Mov	AX,1680h	; give time slice back to Windows
	Int	2Fh		; if program idle
ENDIF
	Mov     AX,-256         ; assume never will get an extended
	Ret                     ; keycode of that number normally
EVEN
Do_Install:
	Call    B$CHK_KB        ; determine KBD type
	Jmp     Short  Main     ; return to main loop
	Assume  ES:NOTHING
WAITFORKEY ENDP

;===========================================================================
; DECLARE SUB CLRKBD ()
; Returns nothing
;
; Clears the Keyboard using BIOS calls.  Have to use BIOS because Tandy
; 1000 did not look at keyboard buffer pointers
;===========================================================================

EVEN
CLRKBD PROC FAR BASIC
	; most compatible & slowest
	;Mov     AX,0C00h	; DOS substitue language is shown
	;Int     21h		; It is 3 times slower but 100%
				; compatible.
IF HAVETANDY
 KStart:            ; compatible & fairly fast works w/ TANDY 1000
	Mov     AH,01		; see if buffer empty
	Int     16h
	JZ      KQuit		; buffer empty if ZF set
	Xor     AH,AH		; if buffer not empty read keystroke
	Int     16h
	Jmp     Short KStart	; and reloop
 KQuit:
	Ret
ELSE
	; very fast but non-compatible with TANDY 1000 series
	Xor     AX,AX		; very fast, no keys to read
	Mov     ES,AX
;	ASSUME  ES:BIOSRAM	; remind programmer
	CLI			; prevent interrupts temporarily
	Mov     AL,ES:[041Ch]	; Refer to actual addresses
	Mov     ES:[041Ah],AL	; using ES: form
	STI			; allow interrupts again
	Ret
ENDIF
	Assume  ES:NOTHING
CLRKBD ENDP

;===========================================================================
; DECLARE SUB KEYPAUSE ()
; Purpose:
;	Clears keyboard buffer and waits for a keystroke.  If gets one
;	 removes keystroke from buffer and returns to program
; Input:
;	Nothing
; Output:
;	Nothing
; Note:
;	Prevents operation of most of QBASICs ON Event GOSUB features
;===========================================================================

EVEN
KEYPAUSE PROC FAR BASIC
IF HAVETANDY
 KStart:            ; compatible & fairly fast works w/ TANDY 1000
	Mov     AH,01		; see if buffer empty
	Int     16h
	JZ      KQuit		; buffer empty if ZF set
	Xor     AH,AH		; if buffer not empty read keystroke
	Int     16h
	Jmp     Short KStart	;and reloop
ELSE
	; very fast but non-compatible with TANDY 1000 series
	Xor     AX,AX		; very fast, no keys to read
	Mov     ES,AX
;	ASSUME  ES:BIOSRAM	; remind programmer
	CLI			; prevent interrupts temporarily
	Mov     AL,ES:[041Ch]	; Refer to actual addresses
	Mov     ES:[041Ah],AL	; using ES: form
	STI			; allow interrupts again
ENDIF
;	Assume  ES:NOTHING
KQuit:
	Mov     AH,1            ; see if buffer empty
	Int     16h
	Jnz	Finis		; if ZF clear, then key found
	Int	28h		; tell DOS & TSR's idle
IF SUPPORTWIN
	Mov	AX,1680h	; give time slice back to Windows
	Int	2Fh		; if program idle
ENDIF
	Jmp	Short KQuit	; else go and wait for keystroke
Finis:	
	Xor	AH,AH		; read and discard keystroke
	Int	16h
	Ret
KEYPAUSE ENDP
END

